/// <reference path="../Src/knockout.validation.js" />

/************************************************
* This is an example localization page. All of these
* messages are the default messages for ko.validation
* 
* Currently ko.validation only does a single parameter replacement
* on your message (indicated by the {0}).
*
* The parameter that you provide in your validation extender
* is what is passed to your message to do the {0} replacement.
*
* eg: myProperty.extend({ minLength: 5 });
* ... will provide a message of "Please enter at least 5 characters"
* when validated
*
* This message replacement obviously only works with primitives
* such as numbers and strings. We do not stringify complex objects 
* or anything like that currently.
*/

ko.validation.localize({
    required: 'Ktelez megadni.',
    min: 'Nem lehet kisebb, mint {0}.',
    max: 'Nem lehet nagyobb, mint {0}.',
    minLength: 'Legalbb {0} karaktert adjon meg.',
    maxLength: 'Legfeljebb {0} karaktert adjon meg.',
    pattern: 'Krem ellenrizze ezt az rtket.',
    step: 'Az rtknek {0} rtkkel kell nvekednie.',
    email: 'A megadott email cm nem rvnyes.',
    date: 'A megadott dtum nem rvnyes.',
    dateISO: 'A megadott dtum nem rvnyes.',
    number: 'Krem szmot adjon meg.',
    digit: 'Krem szmjegyet adjon meg.',
    phoneUS: 'Krem, hogy rvnyes telefonszmot adjon meg.',
    equal: 'Az rtkeknek meg kel egyeznik.',
    notEqual: 'Az rtkeknek klnbznik kell.',
    unique: 'Az rtknek egyedieknek kell lennie.'
});